#include "tree.hpp"
#include "node.hpp"

#include <vector>

Tree::Tree(double* masses, double* particles, double* forces, unsigned nParticles, double size, double* center) {
    particles_ = particles;
    forces_ = forces;
    nParticles_ = nParticles;
    size_ = size;

    for (unsigned i=0; i < 3; ++i) center_[i] = center[i];

    std::vector<unsigned> localParticles_(nParticles_);
    for (unsigned i=0; i < nParticles_; ++i) localParticles_[i] = i;
    
    root_ = new Node();
    *root_ = Node(root_, root_, masses_, particles_, nParticles_, 0, 
                size_, center_, localParticles_, nParticles_);

    allParticles_ = std::vector<unsigned>(nParticles_);
    for (unsigned i=0; i < nParticles_; ++i) allParticles_[i] = i;
}

Tree::~Tree() {
    delete root_;
}

void Tree::calculateForce(unsigned particle) {
    double* force = root_->calculateForce(particle);
    for (unsigned i=0; i < 3; ++i) forces_[3*particle + i] = force[i];
}

void Tree::update() {
    root_->update(allParticles_);
}